unit SQLList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, db, dbTables;

type
    TSQLRec = class(TPersistent)
    private
      FCreationDate: String;
      FAuthor: String;
      FNote: TStrings;
      FSQL: TStrings;
      procedure SetCreationDate(Value: string);
      procedure SetAuthor(Value: String);
      procedure SetNote(Value: TStrings);
      procedure SetSQL(Value: TStrings);
    protected
    public
      constructor Create;
      destructor Destroy; override;
    published
      property CreationDate: String Read FCreationDate write SetCreationDate;
      property Author: String Read FAuthor write SetAuthor;
      property Note: TStrings Read FNote write SetNote;
      property SQL: TStrings Read FSQL write SetSQL;
    end;

type
    TSQLItem = (_SQL1, _SQL2, _SQL3, _SQL4, _SQL5, _SQL6, _SQL7, _SQL8, _SQL9, _SQL10);

type
  TSQLList = class(TComponent)
  private
    FActiveSQL: TSQLItem;
    FActive: Boolean;
    FSQL1: TSQLRec;
    FSQL2: TSQLRec;
    FSQL3: TSQLRec;
    FSQL4: TSQLRec;
    FSQL5: TSQLRec;
    FSQL6: TSQLRec;
    FSQL7: TSQLRec;
    FSQL8: TSQLRec;
    FSQL9: TSQLRec;
    FSQL10: TSQLRec;
    FQuery: TQuery;
    procedure SetSQL1(Value: TSQLRec);
    procedure SetSQL2(Value: TSQLRec);
    procedure SetSQL3(Value: TSQLRec);
    procedure SetSQL4(Value: TSQLRec);
    procedure SetSQL5(Value: TSQLRec);
    procedure SetSQL6(Value: TSQLRec);
    procedure SetSQL7(Value: TSQLRec);
    procedure SetSQL8(Value: TSQLRec);
    procedure SetSQL9(Value: TSQLRec);
    procedure SetSQL10(Value: TSQLRec);
    procedure SetQuery(Value: TQuery);
    procedure SetActive(Value: Boolean);
    procedure SetActiveSQL(Value: TSQLItem);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(Aowner: TComponent); override;
  published
    property Active: Boolean read FActive write SetActive;
    property ActiveSQL: TSQLItem read FActiveSQL write SetActiveSQL;
    property SQL1: TSQLRec read FSQL1 write SetSQL1;
    property SQL2: TSQLRec read FSQL2 write SetSQL2;
    property SQL3: TSQLRec read FSQL3 write SetSQL3;
    property SQL4: TSQLRec read FSQL4 write SetSQL4;
    property SQL5: TSQLRec read FSQL5 write SetSQL5;
    property SQL6: TSQLRec read FSQL6 write SetSQL6;
    property SQL7: TSQLRec read FSQL7 write SetSQL7;
    property SQL8: TSQLRec read FSQL8 write SetSQL8;
    property SQL9: TSQLRec read FSQL9 write SetSQL9;
    property SQL10: TSQLRec read FSQL10 write SetSQL10;
    property Query: TQuery read FQuery write SetQuery;
  end;

procedure Register;

implementation

{$R zsqllist.DCR}

procedure Register;
begin
  RegisterComponents('AZ', [TSQLList]);
end;


constructor TSQLRec.Create;
begin
     inherited;
     FNote := TStringList.Create;
     FSQL  := TStringList.Create;
end;

destructor TSQLRec.Destroy;
begin
     inherited;
     FNote.Free;
     FSQL.FRee;
end;

procedure TSQLRec.SetCreationDate(Value: String);
begin
     FCreationDate := Value;
end;

procedure TSQLRec.SetAuthor(Value: String);
begin
     FAuthor := Value;
end;

procedure TSQLRec.SetNote(Value: TStrings);
begin
     FNote.Assign(Value);
end;

procedure TSQLRec.SetSQL(Value: TStrings);
begin
     FSQL.Assign(Value);
end;



// ***********
// TSQLList
// ***********

constructor TSQLList.Create(Aowner: TComponent);
begin
     inherited;
     FSQL1 := TSQLRec.Create;
     FSQL2 := TSQLRec.Create;
     FSQL3 := TSQLRec.Create;
     FSQL4 := TSQLRec.Create;
     FSQL5 := TSQLRec.Create;
     FSQL6 := TSQLRec.Create;
     FSQL7 := TSQLRec.Create;
     FSQL8 := TSQLRec.Create;
     FSQL9 := TSQLRec.Create;
     FSQL10:= TSQLRec.Create;
     SetActive(False);
     SetActiveSQL(_SQL1);
end;

procedure TSQLList.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if Operation = opRemove then
    if AComponent = Query then Query := nil
end;

procedure TSQLList.SetQuery(Value: TQuery);
begin
  FQuery := Value;
  if Value <> nil then
  begin
    Value.FreeNotification(Self);
  end;
end;

procedure TSQLList.SetSQL1(Value: TSQLRec);
begin
     FSQL1.Assign(Value);
end;

procedure TSQLList.SetSQL2(Value: TSQLRec);
begin
     FSQL2.Assign(Value);
end;

procedure TSQLList.SetSQL3(Value: TSQLRec);
begin
     FSQL3.Assign(Value);
end;

procedure TSQLList.SetSQL4(Value: TSQLRec);
begin
     FSQL4.Assign(Value);
end;

procedure TSQLList.SetSQL5(Value: TSQLRec);
begin
     FSQL5.Assign(Value);
end;

procedure TSQLList.SetSQL6(Value: TSQLRec);
begin
     FSQL6.Assign(Value);
end;

procedure TSQLList.SetSQL7(Value: TSQLRec);
begin
     FSQL7.Assign(Value);
end;

procedure TSQLList.SetSQL8(Value: TSQLRec);
begin
     FSQL8.Assign(Value);
end;

procedure TSQLList.SetSQL9(Value: TSQLRec);
begin
     FSQL9.Assign(Value);
end;

procedure TSQLList.SetSQL10(Value: TSQLRec);
begin
     FSQL10.Assign(Value);
end;


procedure TSQLList.SetActive(Value: Boolean);
begin
     If (Value) and  (FQuery <> nil) then
     begin
          FActive := Value;
          If FActive then
          begin
               Case ActiveSQL of
               _SQL1: FQuery.SQL := FSQL1.SQL;
               _SQL2: FQuery.SQL := FSQL2.SQL;
               _SQL3: FQuery.SQL := FSQL3.SQL;
               _SQL4: FQuery.SQL := FSQL4.SQL;
               _SQL5: FQuery.SQL := FSQL5.SQL;
               _SQL6: FQuery.SQL := FSQL6.SQL;
               _SQL7: FQuery.SQL := FSQL7.SQL;
               _SQL8: FQuery.SQL := FSQL8.SQL;
               _SQL9: FQuery.SQL := FSQL9.SQL;
               _SQL10: FQuery.SQL := FSQL10.SQL;
               end;
          end;
     end
     else FActive := False;
     If FQuery <> nil then
        FQuery.Active := FActive;
end;

procedure TSQLList.SetActiveSQL(Value: TSQLItem);
begin
     FActiveSQL := Value;
     SetActive(True);
end;




end.
